extends Node2D

var blue = preload("res://blue.tscn")
var green = preload("res://green.tscn")
var purple = preload("res://purple.tscn")
var red = preload("res://red.tscn")
var yellow = preload("res://yellow.tscn")
var display = preload("res://clicked_score.tscn")

var bonus_blue = preload("res://bonus_blue.tscn")
var bonus_green = preload("res://bonus_green.tscn")
var bonus_purple = preload("res://bonus_purple.tscn")
var bonus_red = preload("res://bonus_red.tscn")
var bonus_yellow = preload("res://bonus_yellow.tscn")

var block
var scene
var temp_score:int = 0
var score:int = 0
var bonus_needed = 10
var can_get_bonus = true

var block_location = Vector2()

func _ready():
	
	first_load()
	
	
func first_load():
	randomize()
	block_location = Vector2(25,575)
	
	for i in range (11):
		for x in range (20):
			randomize_block()
			var scene_instance = scene.instance()
			scene_instance.position = block_location
			add_child(scene_instance)
			block_location.x += 50
		block_location.y -= 47
		block_location.x = 25

		

func randomize_block():
	randomize()
	block = int(rand_range(1,6))
	if block == 1:
		scene = blue
	elif block == 2:
		scene = green
	elif block == 3:
		scene = purple
	elif block == 4:
		scene = red
	elif block == 5:
		scene = yellow
	else:
		scene = yellow
	
func wait_for_repopulate():
	$fall_timer.start()


func _on_fall_timer_timeout():
	$explode.stop()
	global.repopulate = true
	global.is_clickable = true
	global.time_up = true
	$up_timer.start()
	

func do_repopulate(reported_position):
	randomize_block()
	var scene_instance = scene.instance()
	scene_instance.position = reported_position
	add_child(scene_instance)
	$coin.play()
	$coin_delay.start()

func create_bonus_node():
	var scene
	if global.match_color[0] == "blue":
		scene = bonus_blue
	if global.match_color[0] == "red":
		scene = bonus_red
	if global.match_color[0] == "purple":
		scene = bonus_purple
	if global.match_color[0] == "green":
		scene = bonus_green
	if global.match_color[0] == "yellow":
		scene = bonus_yellow
	var scene_instance = scene.instance()
	scene_instance.position = global.mouse_location
	add_child(scene_instance)
	

func _on_up_timer_timeout():
	global.time_up = false

func get_score(click_score):
	temp_score += click_score

func display_clicked():
	global.clicked_score = temp_score
	if global.clicked_score >= bonus_needed and can_get_bonus:
		create_bonus_node()
	var scene_instance = display.instance()
	scene_instance.position = global.mouse_location
	add_child(scene_instance)
	

func reset_temp():
	score += temp_score
	display_clicked()
	temp_score = 0
	print (str(score))
	$Score.text = ("Score = "+str(score))
	
func explode():
	$explode.play()


func _on_coin_delay_timeout():
	$coin.stop()
	

func do_bonus():
	can_get_bonus = false
	var x = get_tree().get_nodes_in_group(global.match_color[0]).size()
	temp_score = x * 2
	reset_temp()
	var y = get_tree().get_nodes_in_group(global.match_color[0])
	print ("hello")
	print (global.match_color)
	print (x)
	for i in (x):
		y[i].queue_free()
	explode()
	can_get_bonus = true
