extends RigidBody2D

var report_position = Vector2()


func _input_event(viewport, event, shape_idx):
	if event is InputEventMouseButton and event.button_index == BUTTON_LEFT and event.pressed and global.is_clickable:
		global.match_color = get_groups()
		global.repopulate = false
		global.is_clickable = false
		global.mouse_location = self.position
		get_parent().explode()
		get_matches()
		get_parent().reset_temp()
		get_parent().wait_for_repopulate()
		queue_free()
		
func get_matches():
	var click_score:int = 0
	if $down_sensor.is_colliding():
		var down = $down_sensor.get_collider()
		var down_group = down.get_groups()
		if down_group == global.match_color:
			$down_sensor.enabled = false
			click_score = 1
			down.get_matches()
			down.queue_free()
			
	if $right_sensor.is_colliding():
		var right = $right_sensor.get_collider()
		var right_group = right.get_groups()
		if right_group == global.match_color:
			$right_sensor.enabled = false
			click_score = 1
			right.get_matches()
			right.queue_free()
			
	if $left_sensor.is_colliding():
		var left = $left_sensor.get_collider()
		var left_group = left.get_groups()
		if left_group == global.match_color:
			$left_sensor.enabled = false
			click_score = 1
			left.get_matches()
			left.queue_free()
			
	if $up_sensor.is_colliding():
		var up = $up_sensor.get_collider()
		var up_group = up.get_groups()
		if up_group == global.match_color:
			$up_sensor.enabled = false
			click_score = 1
			up.get_matches()
			up.queue_free()
		
	get_parent().get_score(click_score)
		
func _process(delta):
	if global.repopulate:
		if !$up_sensor.is_colliding():
			global.repopulate = false
			report_position = self.position
			report_position.y -= 47
			get_parent().do_repopulate(report_position)
			$delay.start()
			
	if global.repopulate and !global.time_up:
		if !$left_sensor.is_colliding():
			global.repopulate = false
			report_position = self.position
			report_position.x -= 50
			get_parent().do_repopulate(report_position)

			$delay.start()
			
	if global.repopulate and !global.time_up:
		if !$right_sensor.is_colliding():
			global.repopulate = false
			report_position = self.position
			report_position.x += 50
			get_parent().do_repopulate(report_position)
			$delay.start()

func _on_delay_timeout():
	global.repopulate = true
	pass
